#ifndef IBN_DEVICE_DEPOLARIZER_H
#define IBN_DEVICE_DEPOLARIZER_H
#include "Device.h"
namespace device 
{
	class Depolarizer : public  Device
	{
		public:
			virtual ~Depolarizer(void){};
			virtual void    start_scan() = 0;
			virtual void     stop_scan() = 0;
			virtual void    pause_scan() = 0;
			virtual void continue_scan() = 0;
			virtual bool       is_scan() const = 0;
			virtual bool         is_on() const = 0;

			virtual void           off() = 0 ;     //turn off the generator
			virtual void            on() = 0;     //turn on the generator
			virtual void            on(double f) = 0; //turn on the generator with spec frequency f in Hz

			virtual void set_attenuation(double a) = 0; //set attenuation
			//virtual void set_attenuation(void) = 0 ;    //set default attenuation

			virtual double get_attenuation(void) const  = 0;

			virtual void set_speed(double) = 0; 
			virtual void set_step(double)  = 0;
			virtual void set_initial(double f) = 0;
			virtual void set_final(double f) = 0;
			virtual void set_frequency(double f) = 0;
			virtual void set_width(double width) = 0;
			virtual void set_delay(double delay) = 0;

			virtual void set_harmonic_number(int n) = 0;
			virtual void set_revolution(double ) = 0;

			virtual double get_frequency(void) const  = 0;
			virtual double get_initial(void) const = 0; 
			virtual double get_final(void) const = 0; 
			virtual double get_speed(void) const = 0;
			virtual double get_step(void) const = 0;
			virtual double get_width(void) const = 0;
			virtual double get_delay(void) const = 0;

			virtual int get_harmonic_number() const = 0;
			virtual double get_revolution(void) const = 0;
	};
}
#endif
