#ifndef IBN_DEVICE_H
#define IBN_DEVICE_H

#include <string>

namespace device {

	struct Info 
	{
		std::string type;  //device type
		std::string model; //device model
		std::string address; //unique device address
		std::string name;  //logical deivce name (could be any)
		std::string version; //SN and version
		std::string serial_number;
		const std::string & Type(void)    const  { return type; } 
		const std::string & Model(void)   const  { return model; } 
		const std::string & Address(void) const  { return address;} 
		const std::string & Name(void)    const  { return name; } 
		const std::string & Version(void) const  { return version; }
		const std::string & SerialNumber(void) const  { return serial_number; }
	};

	class Device
	{
		public:
			virtual ~Device(void){}
			virtual const Info & GetInfo(void) const  = 0;
//			virtual const std::string & GetType(void)    const  = 0;
		protected:

	};
}
#endif
